//
//  RelevantTestcasesController.m
//  linenumber_plugin
//
//  Created by Henning Kiel on 30.04.09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "RelevantTestcasesController.h"
#import "RelevantTestcases.h"
#import "RegexKitLite.h"

@implementation RelevantTestcasesController

- (void) dealloc
{
  [relevantTestCases removeObserver:self forKeyPath:nil];
  [relevantTestCases release];
  
  [super dealloc];
}

- (void)windowDidLoad;
{
  [resultTable setTarget:self];
  [resultTable setDoubleAction:@selector(openTestFile:)];
}

// Called by the coverage data file menu items.
- (IBAction)loadCoverageDataFor:(id)sender;
{
  [relevantTestCases setDataFileTo:[sender title]];
}

- (IBAction)openTestFile:(id)sender;
{
  NSUInteger selectedIndex = [resultController selectionIndex];
  if (selectedIndex == NSNotFound)
    return;

  NSDictionary *selectedObject = [[resultController arrangedObjects] objectAtIndex:selectedIndex];
  NSString *fullFilePath = [[NSString pathWithComponents:[NSArray arrayWithObjects:[[relevantTestCases metaData] objectForKey:@"base_dir"], [selectedObject objectForKey:@"test_file"], nil]] stringByStandardizingPath];
  NSURL *textMateUrl = [NSURL URLWithString:[NSString stringWithFormat:@"txmt://open/?url=file://%@&line=%@&column=1", fullFilePath, [selectedObject objectForKey:@"line_nr"]]];
  NSLog(@"url: %@", textMateUrl);
  
  [relevantTestCases ignoreLineChangeUntilFileChange];
  
  [[NSWorkspace sharedWorkspace] openURL:textMateUrl];
}

- (void)setRelevantTestcases:(RelevantTestcases *)newRelevantTestCases;
{
  [relevantTestCases removeObserver:self forKeyPath:nil];
  [relevantTestCases autorelease];
  relevantTestCases = [newRelevantTestCases retain];
  [relevantTestCases addObserver:self forKeyPath:@"relevantTestCases" options:NSKeyValueObservingOptionNew context:NULL];
}

- (void)observeValueForKeyPath:(NSString *)keyPath ofObject:(id)object change:(NSDictionary *)change context:(void *)context;
{
  if (object == relevantTestCases && [keyPath isEqualToString:@"relevantTestCases"])
  {
    [self willChangeValueForKey:@"relevantTestCases"];
    [self didChangeValueForKey:@"relevantTestCases"];
  }
}

- (RelevantTestcases *)relevantTestCases;
{
  return relevantTestCases;
}
@end
