//
//  LineNumberPlugin.h
//  linenumber_plugin
//
//  Created by Henning Kiel on 29.04.09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class RelevantTestcases;
@class RelevantTestcasesController;


@protocol TMPlugInController
- (float)version;
@end

@interface TestSuggestionsPlugin : NSObject {
  NSNumber *lineNumber;
  NSString *filePath;
  RelevantTestcases *relevantTestCases;
  RelevantTestcasesController *relevantTestCasesController;
  
  NSMenu *windowMenu;
  NSMenu *dataFilesMenu;
  NSMenuItem *showTestCaseSuggestionsMenuItem;
  NSMenuItem *coverageDataMenuItem;
}

- (id)initWithPlugInController:(id <TMPlugInController>)aController;

- (void)didChangeFileTo:(NSString *)newFileName;
- (void)didChangeLineNumberTo:(NSNumber *)newLineNumber;

- (IBAction)showSuggestions:(id)sender;
@end
